unit PureAgent2008Unit;
//
// Demonstration project for implementing Microsoft Agents(TM) in Delphi
//
//   // Revised November 1998 for Agent 2.0
//      Revised January 2008 for SAPI 5.3 and VISTA
//
// **********************************************************************
//
// Richard Minutillo  -  rgm at fabandpp.org
//
// requires that you have installed the Microsoft Agent Control
// on your system, by 'importing' the ActiveX control into Delphi.
//
// The Agent control, in turn, requires that you have installed
// the Agent Server on some older versions of Windows, and of course
// in all versions have at least one agent character installed.
//
// You also need a voice recognition engine and a text-to-speech
// engine, both of which are installed by default in current versions of
// Windows.
//
// Visit the microsoft site
//
//           http://www.microsoft.com/msagent/
//
// for all of that stuff for for other information.
//
// There are other third-party resources available on the web,
// but mostly for developing web pages, which was the original
// target platform for Agent technology.
//
// Freeman Labs also published a pure VCL component for Delphi, but that
// site is now an online gaming cafe. Steve Freeman did provided
// valuable advice to me, however, so you should check out his site:
//
//           http://www.freemanlabs.com
//
// **********************************************************************
//
//
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, AgentObjects_TLB, StdCtrls, ComCtrls, ExtCtrls, Buttons, ActiveX,
  VersInfo, lmdcompo, lmdclass, lmdctrl, lmddlgS, lmdstdcS, lmdextcS,
  lmdcctrl, LMDCustomComponent, LMDContainerComponent, LMDBaseDialog,
  LMDAboutDlg, LMDCustomSimpleLabel, LMDSimpleLabel, LMDControl,
  LMDBaseControl, LMDBaseGraphicControl, LMDBaseLabel, LMDInformationLabel,
  LMDCustomControl, LMDCustomPanel, LMDCustomBevelPanel,
  LMDCustomStatusBar, LMDStatusBar;

type
  TfrmAgentTest = class(TForm)
    LMDAboutDlg1: TLMDAboutDlg;
    VersInfo1: TVersInfo;
    LMDInformationLabel2: TLMDInformationLabel;
    LMDSimpleLabel1: TLMDSimpleLabel;
    Agent1: TAgent;  // you don't need the control, just the declaration
                     // as long as the control is available and in the path
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    pnlRight: TPanel;
    btnHide: TButton;
    btnLoad: TButton;
    btnAddCmds: TButton;
    btnUnLoad: TButton;
    btnClose: TButton;
    btnAnimate: TButton;
    ckRequest: TCheckBox;
    pnlLeft: TPanel;
    cbCharacters: TComboBox;
    Memo2: TMemo;
    Memo1: TMemo;
    Label2: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    btnTour: TButton;
    edSpeed: TEdit;
    Label4: TLabel;
    ckFollow: TCheckBox;
    ckFast: TCheckBox;
    btnStopAll: TButton;
    lbFast: TLabel;
    UpDown1: TUpDown;
    cbAnims: TComboBox;
    Label6: TLabel;
    ckWaitFor: TCheckBox;
    lbStatus: TListBox;
    StatusBar2: TStatusBar;
    btnCharForm: TButton;
    btnListen: TButton;
    btnDefDialog: TButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel4: TBevel;
    btnSpeak: TButton;
    btnThink: TButton;
    Label7: TLabel;
    btnPopupMenu: TButton;
    ckDefault: TCheckBox;
    Label8: TLabel;
    btnPropSheet: TButton;
    Bevel3: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    LMDStatusBar1: TLMDStatusBar;
    GroupBox1: TGroupBox;
    ckNoBalloon: TCheckBox;
    procedure btnLoadClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure LoadAgents;
    procedure AddCommands;
    procedure UnLoadAgents;
    procedure AnimateAgent;
    procedure ShowAgent;
    procedure HideAgent;
    procedure btnHideClick(Sender: TObject);
    procedure btnUnLoadClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btnAnimateClick(Sender: TObject);
    procedure Agent1Move(Sender: TObject; const CharacterID: WideString; x,
      y, Cause: Smallint);
    procedure Agent1Show(Sender: TObject; const CharacterID: WideString;
      Cause: Smallint);
    procedure Agent1Hide(Sender: TObject; const CharacterID: WideString;
      Cause: Smallint);
    procedure Agent1Command(Sender: TObject; UserInput: IDispatch);
    procedure btnCloseClick(Sender: TObject);
    procedure btnAddCmdsClick(Sender: TObject);
    procedure Agent1IdleStart(Sender: TObject;
      const CharacterID: WideString);
    procedure FormCreate(Sender: TObject);
    procedure cbCharactersChange(Sender: TObject);
    procedure btnSpeakClick(Sender: TObject);
    procedure Agent1ActivateInput(Sender: TObject;
      const CharacterID: WideString);
    procedure Agent1BalloonHide(Sender: TObject;
      const CharacterID: WideString);
    procedure Agent1BalloonShow(Sender: TObject;
      const CharacterID: WideString);
    procedure Agent1Click(Sender: TObject; const CharacterID: WideString;
      Button, Shift, x, y: Smallint);
    procedure Agent1DblClick(Sender: TObject;
      const CharacterID: WideString; Button, Shift, x, y: Smallint);
    procedure Agent1DeactivateInput(Sender: TObject;
      const CharacterID: WideString);
    procedure Agent1DragComplete(Sender: TObject;
      const CharacterID: WideString; Button, Shift, x, y: Smallint);
    procedure Agent1DragStart(Sender: TObject;
      const CharacterID: WideString; Button, Shift, x, y: Smallint);
    procedure Agent1IdleComplete(Sender: TObject;
      const CharacterID: WideString);
    procedure Agent1Bookmark(Sender: TObject; BookmarkID: Integer);
    procedure Agent1Restart(Sender: TObject);
    procedure Agent1Shutdown(Sender: TObject);
    procedure Agent1Size(Sender: TObject; const CharacterID: WideString;
      Width, Height: Smallint);
    procedure Agent1RequestStart(Sender: TObject; Request: IDispatch);
    procedure Agent1RequestComplete(Sender: TObject; Request: IDispatch);
    procedure btnTourClick(Sender: TObject);
    procedure pnlLeftMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnStopAllClick(Sender: TObject);
    procedure cbAnimsChange(Sender: TObject);
    //
    function GetWinDirectory: String;
    procedure btnDefDialogClick(Sender: TObject);
    procedure Agent1ActiveClientChange(Sender: TObject;
      const CharacterID: WideString; Active: WordBool);
    procedure Agent1HelpComplete(Sender: TObject; const CharacterID,
      Name: WideString; Cause: Smallint);
    procedure Agent1ListenComplete(Sender: TObject;
      const CharacterID: WideString; Cause: Smallint);
    procedure btnPopupMenuClick(Sender: TObject);
    procedure btnListenClick(Sender: TObject);
    procedure Agent1ListenStart(Sender: TObject;
      const CharacterID: WideString);
    procedure btnThinkClick(Sender: TObject);
    procedure Agent1DefaultCharacterChange(Sender: TObject;
      const GUID: WideString);
    procedure Agent1AgentPropertyChange(Sender: TObject);
    //
    function BSDeCode(Button, Shift: smallint): string;
    procedure statusmessage(s: string);
    procedure SafePlay(AnimationName: string);
    procedure Speakit(SText, BText: string; Think: boolean);
    procedure SpeakitV(SText, BText: string; Think: boolean);
    procedure JustSpeak(SText: string);
    //
    procedure StatusBar1Click(Sender: TObject);
    procedure StatusBar1DblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnCharFormClick(Sender: TObject);
    procedure ckDefaultClick(Sender: TObject);
    procedure ckJustBalloonClick(Sender: TObject);
    procedure btnPropSheetClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure LMDInformationLabel2Click(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
  private
    BuildString: string;
  //
  //    I was playing around with the system menu...
  //
    procedure WMSysCommand(var Msg: TWMSysCommand);
          message WM_SYSCOMMAND;
    { Private declarations }
  public
    { Public declarations }
    //
    // These declared here so they can be shared by the other form
    //
    //var
    //ThisChar:  IAgentCtlCharacter;    // references replaced with ThisCharEx
    ThisCharEX:  IAgentCtlCharacterEx;  // new in version 2.0
    CharAnims:   IAgentCtlAnimationNames;
    ThisCmd:     IAgentCtlUserInput;
    ThisRequest,
    TourRequest,
    GestRequest,
    SpchRequest,
    AnimRequest: IAgentCtlRequest; // Request objects are global so they will
                                   // stay in scope
                                   //
                                   // as of SAPI 5.3 or so this comes back as
                                   // nil and consequently is unusable

    AgtCmds: array[0..5] of IAgentCtlCommand;
    AgtCmdsEx: array[0..5] of IAgentCtlCommandEx;
    AgtCmdSet: IAgentCtlCommandsEx; // not useful?
    //
    AgentLoaded: boolean;  // to track inside program for convenience
    //
    AgentPath: string;
    //
    BalloonShown: boolean;  // not used
    procedure DisplayHint(Sender: TObject);
  end;

var
  frmAgentTest: TfrmAgentTest;

implementation

{$R *.DFM}

uses CharForm;

var
   cmdName: array[0..5] of
    widestring = ('Jump',
                  'Wave',
                  'PropSheet',
                  'Tour',
                  'Animate',
                  'Relax');
   cmdVoiceCaption: array[0..5] of
    widestring = ('Jump',
                  'Wave',
                  'PropSheet',
                  'Tour',
                  'Animate',
                  'Relax');
   //
   // cannot be initialized
   //
   cmdCaption: array[0..5] of oleVariant;
   cmdVoice: array[0..5] of oleVariant;
   cmdVisible: array[0..5] of oleVariant;
   cmdEnable: array[0..5] of oleVariant;
   //
const
   SC_MyMenuItem = WM_USER + 1;
   //
   messageshown: boolean = false;
   //
   BalloonOn: longint = 1;
   SizeToText: longint = 2;
   AutoHide: longint = 4;
   AutoPace: longint = 8;

//
// System Routines
//

procedure TfrmAgentTest.WMSysCommand(var Msg: TWMSysCommand);
 //
 //  this just executes the About Box command
 //    which is added to the system menu during initialization...
 //
    begin
      if Msg.CmdType = SC_MyMenuItem then begin
       LMDAboutDlg1.CaptionTitle := Buildstring;
       LMDAboutDlg1.ExecuteEnh(frmAgentTest);
       end
      else
       inherited;
end;

procedure TFrmAgentTest.DisplayHint(Sender: TObject);
begin
   StatusBar1.Panels[0].text := GetLongHint(Application.Hint);
end;

//
// Initialization Routines
//


procedure TFrmAgentTest.FormActivate(Sender: TObject);
var found: integer;
    exerec: TSearchRec;
begin
    found:=findfirst(application.exename,faAnyFile,exerec);
    versinfo1.FileName := exerec.Name;
    Buildstring :='Build ' + versinfo1.ModuleVersionNumber
     + ': ' + FormatDateTime('dddd, mmmm d, yyyy '
     + '"at" h:mm am/pm', filedatetodatetime(exerec.Time));
    FindClose(exerec);
end;

procedure TfrmAgentTest.FormCreate(Sender: TObject);
var SearchRec: TSearchRec;
    i: integer;
begin
 //
 //  this piece of business has nothing to do with Agents
 //    but I was playing around with the system menu...
 //
 AppendMenu(GetSystemMenu(Handle, FALSE), MF_SEPARATOR, 0, '');
 AppendMenu(GetSystemMenu(Handle, FALSE),
   MF_STRING,
   SC_MyMenuItem,
   '&About');
 LMDSimpleLabel1.Caption := 'See system menu for About box';
 //
 Application.OnHint := DisplayHint;
 //
 //  initialize some items
 //
 for i := 0 to 5 do begin
     cmdCaption[i] := cmdName[i];
     cmdVisible[i] := true;
     cmdEnable[i] := true;
     case i of
       0: cmdVoice[i] := '[jump|leap|get up]';
       1: cmdVoice[i] := '[wave|say hello]';
       2: cmdVoice[i] := '[...properties...]';
       3: cmdVoice[i] := '[...tour...]';
       4: cmdVoice[i] := '[animate|...something wonderful...|go*]';
       5: cmdVoice[i] := '[relax|OK*|enough already]';
       end;
     end;
 //
 // find all the agents in the new version 2.0 default Agent Path
 //
 //
 agentloaded := false;  // initialize here cause it's declared in public
 //
 AgentPath := GetWinDirectory + '\MSAgent\Chars\';    //<--needs to match your system
 //
 if FindFirst(AgentPath + '*.acs', 0, SearchRec) = 0 then begin
   cbCharacters.Items.Add(Copy(SearchRec.Name,1,Pos('.',SearchRec.Name) -1 ));
   while FindNext(SearchRec)=0 do
     cbCharacters.Items.Add(Copy(SearchRec.Name,1,Pos('.',SearchRec.Name) - 1));
   end;
 cbCharacters.itemindex:=0;
 //
end;

procedure TfrmAgentTest.FormShow(Sender: TObject);
begin
     statusbar1.panels[0].width := pnlLeft.Width;
     statusbar2.panels[0].width := pnlLeft.Width;
end;

//
// General Agent Routines
//

procedure TfrmAgentTest.LoadAgents;
var //CharAnims: IAgentCtlAnimationNames;
    MyEnumVariant: IEnumVariant;
    //msg: array[0..100] of olevariant;   // 100 is arbitrary limit
    //pceltfetched: PLongInt;
    pceltfetched: Cardinal;
    i: integer;
    msg, Loadkey: olevariant;
begin
     //
     // Agent1.Connected:=true;         // automatic in 2.0
     //
     try
     //
     if not ckDefault.checked then begin
      Agent1.Characters.Load(cbcharacters.items[cbCharacters.itemindex],
         agentPath + cbcharacters.items[cbCharacters.itemindex] + '.acs');
      //ThisChar:=Agent1.Characters[cbcharacters.items[cbCharacters.itemindex]];
      ThisCharEx:=Agent1.Characters[cbcharacters.items[cbCharacters.itemindex]];
      statusmessage('Agent Server Active; ' +
        cbcharacters.items[cbCharacters.itemindex] + 'Agent Loaded');
      end
     else begin  // to load default character you MUST supply
                 // second parameter and it MUST be undefined
      Agent1.Characters.Load('DefChar', LoadKey);
      ThisCharEx:=Agent1.Characters['DefChar'];
      statusmessage('Agent Server Active; Default Agent Loaded');
      end;
     //
     // added based on tip from Peter, aka "utilmind" <utilmind@goplay.com>
     //   [probably no longer necessary since TTS v5, which defaults to 1033
     //ThisCharEx.Set_LanguageID(1033);
     //
     //  Also worth noting that the character will grab the first
     //  available voice that matches its gender, starting with the
     //  default and then going down the list. The SAPI5.1 installs
     //  MS Mike and MS Mary, which don't work under VISTA, and the
     //  male agents find MS Mike are try to use it, and hence remain
     //  silent. You need to get rid of the non-functional voices. The
     //  'gotcha' at this point is that there is no make voice installed
     //  by default in Windows, and most agents are male... Hmm.
     //
     AgentLoaded:=true;
     //
     cbAnims.Clear;
     //
     // information about IEnumVariant from Steve Freeman of Freeman Labs
     //
     //CharAnims := ThisCharEX.AnimationNames;  // see next statement
     //
     //  what we're doing here is reading the list of available
     //  animations for the particular agent we loaded, and adding the
     //  name of the animation to a combo box for later use
     //
     i := 0;
     MyEnumVariant := (ThisCharEX.AnimationNames.Enum as IEnumVariant);
     MyEnumVariant.Reset; // we're iterating the collection
       try
       while MyEnumVariant.Next(1, msg, PceltFetched) = 0 do begin
          inc(i);
          memo1.lines.add(msg + ' animation retrieved');
          cbAnims.items.add(msg);
          end;
       //
       memo1.lines.add(inttostr(i) + ' animations total');
       cbAnims.itemindex := 0;
       //
       except
       statusmessage('Enum Method Failed!')
       end;
     //
     except
     statusmessage('Agent Load Failed!');
     end;
 end;

procedure TfrmAgentTest.ShowAgent;
begin
     // ckFast is used as the parameter, which loads with or without
     //    fancy animation
     //
     ThisCharEx.Show(ckFast.Checked);
     //
     //  syntax below also works, but it's ugly
     //  Agent1.Characters['merlin'].Show(0);
     //
     statusmessage('Selected Agent Displayed');
end;

procedure TfrmAgentTest.cbCharactersChange(Sender: TObject);
begin
     if AgentLoaded then begin
       UnLoadAgents;
       LoadAgents;
       ShowAgent;
       end;
end;

procedure TfrmAgentTest.AddCommands;
var i: integer;
begin
   //
   // This adds to the default voice and on-screen command menu,
   //
   // Apparently, you MUST add the individual commands
   // before adding their <caption> otherwise they
   // don't work well, and they won't unload cleanly
   //
  for i:= 0 to 5 do begin
     //
     // remember we initialized these command array variables above
     //   now we're loading them into the agent
     //
     //   these commands are indeed stupid, but if you were customizing to
     //   make your agent control your program through voice recognition...
     //
     AgtCmds[i] := ThisCharEx.Commands.Add(cmdName[i],
                                           cmdCaption[i],
                                           cmdVoice[i],
                                           cmdEnable[i],
                                           cmdVisible[i]);
     AgtCmdsEx[i] := ThisCharEx.Commands.Command(cmdName[i]);
     AgtCmdsEx[i].VoiceCaption := cmdCaption[i]
     end;
   //
   // which appear under the caption <group> Stupid Agent Tricks
   //
   ThisCharEx.Commands.Voice :='Stupid Agent Tricks';   // for backward comp
   ThisCharEx.Commands.VoiceCaption:='Stupid Agent Tricks';  // new in 2.0
   //
   // which needs a voice (vocal name)
   //
   ThisCharEx.Commands.Voice:='Stupid Tricks';
   //
   // and must be made visible in the popup menu visible
   //
   ThisCharEx.Commands.Visible:=true;
   //
   // and can have a default (new in version 2.0)
   //
   ThisCharEx.Commands.DefaultCommand := CmdName[0];
   //
   statusmessage(inttostr(ThischarEx.commands.count)
    + ' Commands Added as ' + ThischarEx.commands.caption);
end;

procedure TfrmAgentTest.SpeakIt(SText, BText: string; Think: boolean);
begin
    //
    // routine which or speaks or thinks, with or without balloon
    //
    // this routine uses the tag syntax which MS abandoned in the
    // version 5 TTS engines in favor of XML. Since VISTA uses TTS
    // version 5 these routines fail.
    //
    // see http://msdn2.microsoft.com/en-us/library/ms695905(VS.85).aspx
    //
    //   ORIGINAL COMMENTS BELOW
    //
    // Thinks or speaks passed text with or without text balloon
    // using the map tag which, in general, looks like:
    //
    //    \map="Speaks"="Balloon"\
    //
    //    #34 = '"'
    //
    //
    // --> Could also check here for good speech conditions:
    //       not in listen mode, speech engine available, etc.
    //
    //
{    if (not ckNoBalloon.checked) then
       if not Think then
           if ckRequest.Checked then begin
               SpchRequest := ThisCharEx.Speak('\map=' + #34 + Stext + #34
                     + '=' + #34 + BText + #34 + '\','');
               Memo1.Lines.Add('Queued Request ID:' + inttostr(SpchRequest.ID));
               end
           else
               ThisCharEx.Speak('\map=' + #34 + Stext + #34
                     + '=' + #34 + BText + #34 + '\','')
       else
           if ckRequest.Checked then begin
               SpchRequest := ThisCharEx.Think('\map=' + #34 + Stext + #34
                     + '=' + #34 + BText + #34 + '\');
               Memo1.Lines.Add('Queued Request ID:' + inttostr(SpchRequest.ID));
               end
           else
               ThisCharEx.Think('\map=' + #34 + Stext + #34
                     + '=' + #34 + BText + #34 + '\')
    else
               if ckRequest.Checked then begin
                   SpchRequest := ThisCharEx.Think('\map=' + #34 + '' + #34
                         + '=' + #34 + BText + #34 + '\');
                   Memo1.Lines.Add('Queued Request ID:' + inttostr(SpchRequest.ID));
                   end
               else
                   ThisCharEx.Think('\map=' + #34 + '' + #34
                         + '=' + #34 + BText + #34 + '\')

        else //if ckNoBalloon.Checked then
           if not Think then
               if ckRequest.Checked then begin
                   SpchRequest := ThisCharEx.Speak('\map=' + #34 + Stext + #34
                         + '=' + #34 + '' + #34 + '\','');
                   Memo1.Lines.Add('Queued Request ID:' + inttostr(SpchRequest.ID));
                   end
               else
                   ThisCharEx.Speak('\map=' + #34 + SText + #34
                         + '=' + #34 + '' + #34 + '\','')
           else
               if ckRequest.Checked then begin
                   SpchRequest := ThisCharEx.Think('\map=' + #34 + Stext + #34
                         + '=' + #34 + '' + #34 + '\');
                   Memo1.Lines.Add('Queued Request ID:' + inttostr(SpchRequest.ID));
                   end
               else
                   ThisCharEx.Think('\map=' + #34 + Stext + #34
                         + '=' + #34 + '' + #34 + '\')
}
end;

procedure TfrmAgentTest.SpeakitV(SText, BText: string; Think: boolean);
begin
    //
    // new version of routine which or speaks or thinks
    //
    // this routine will eventually use the new XML based
    // syntax, but for now just speaks, or thinks, just to
    // get it working in VISTA. I hope to figure out the new
    // balloon control at some point
    //
    // Since the Balloon visibility is now directly controlled
    // by the checkbox, I don't have to check for that.
    //
    // Unfortunately, however, the ability to have the balloon display
    // something different from the speech is gone, or unknown to me, so the
    // distinction between BText and SText is moot. I leave them
    // both in as parameters in case I figure it out later. Meanwhile
    // I use BText in THINK statements and STest in SPEAK.
    //
    // --> Could also check here for good speech conditions:
    //       not in listen mode, speech engine available, etc.
    //
    //
        if not Think then
               if ckRequest.Checked then begin
                   SpchRequest := ThisCharEx.Speak(Stext,'');
                   Memo1.Lines.Add('Queued Request ID:' + inttostr(SpchRequest.ID));
                   end
               else
                   ThisCharEx.Speak(SText,'')
          else
               if ckRequest.Checked then begin
                   SpchRequest := ThisCharEx.Think(Btext);
                   Memo1.Lines.Add('Queued Request ID:' + inttostr(SpchRequest.ID));
                   end
               else
                   ThisCharEx.Think(Btext);
end;

procedure TfrmAgentTest.JustSpeak(SText: string);
begin
    //
    // Speaks passed text straight
    //  this is the most direct approach to agent speech
    //
    if ckRequest.checked then begin
      SpchRequest := ThisCharEx.Speak(SText,'');
      Memo1.Lines.Add('Queued Request ID:' + inttostr(SpchRequest.ID));
      end
    else
      ThisCharEx.Speak(SText,'');
End;

procedure TfrmAgentTest.Safeplay(AnimationName: string);
begin
   //
   // obviously, this routine expects you have that
   // combo box of valid animations.....
   //
   if cbanims.items.indexof(AnimationName) <> -1 then
    ThisCharEx.Play(AnimationName)
   else  // this is never hit, since the list only contains valid
         // animations by default, but why not...
    ThisCharEx.Speak('...but \emp\I can' + #39 + 't \emp\do ' +
     AnimationName,'');
end;

procedure TfrmAgentTest.AnimateAgent;  // do some cute stuff
var
 ax, ay: integer;
begin
   SafePlay('Surprised');
   Safeplay('Acknowledge');
   SafePlay('Greet');
   JustSpeak('Hello.|\Emp\Hi ya!|Nice to see you');
   Safeplay('Acknowledge');
   //
   // Go Somewhere
   //
   Ax := frmAgentTest.Left;
   Ay := frmAgentTest.Top;
   ThisCharEx.MoveTo(Ax, Ay, strtoint(edSpeed.text));
   //
   // Do Something Wonderful (in version 2.0 all MS Agents can)
   //
   SafePlay('DoMagic1');
   SafePlay('DoMagic2');
   //
   JustSpeak('You really know your agents!');
   SafePlay('Congratulate');
   //
   // Say Bye Bye
   //
   SafePlay('Wave');
   ThisCharEx.IdleOn;
   end;

procedure TfrmAgentTest.cbAnimsChange(Sender: TObject);
begin
  //
  // in version 2.0 a list of animations is available through the
  //    IAgentCtlCharacterEx interface
  //
  // watch out selecting animations which end in 'ing...' because
  // they may continue indefinitely. In this program you can use
  // the 'Stop Queued' button
  //
  if AgentLoaded then
    try
    if ckRequest.Checked then begin
      SafePlay(cbAnims.items[cbanims.itemindex]);
      //
      //Memo1.Lines.Add('Queued Request ID:' + inttostr(AnimRequest.ID));
      //    taken out because Annu=iRequest.ID comes back as nil
      Memo1.Lines.Add('Animation Request Queued');
      end
    else
      SafePlay(cbAnims.items[cbanims.itemindex]);
    except    // should never happen because animations derived from character!
     try
     ThisCharEx.Play('Confused');
     except
     ThisCharEx.Speak('gulp','');
     end;
    ThisCharEx.Speak('I cannot perform"' + cbAnims.items[cbanims.itemindex]
       + '". Very \Emp\Sorry.','');
    end;
end;

procedure TfrmAgentTest.HideAgent;
begin
     try
     if not ThisCharEx.Get_HasOtherClients then begin
     //
     // this is only one possibility. You could also check for
     // agents not being active for input, or still processing a
     // request, etc.
     //
        ThisCharEx.Hide(ckFast.Checked);
                                       // this is another way to wait for
        While ThisCharEx.Get_Visible do; // completion of animation without
                                       // generating and tracking a request obj

        statusmessage('Selected Agent Hidden');
        btnHide.Enabled:=false;
        end
     else
        statusmessage('Agent Has Other Clients'); // be polite
     except
     statusmessage('Unspecified Error!');
     end; //try
end;

procedure TfrmAgentTest.UnLoadAgents;
begin
    //
    if ThisCharEx.Commands.Count > 0 then begin
      ThisCharEx.Commands.RemoveAll;
      statusmessage('Agent Commands Removed');
      end;
    //
    if ThisCharEx.Get_Visible then HideAgent;
    //
    try
     Agent1.Characters.Unload(ThisCharEx.Name);
    except
     //
     // kludge alert!
     //
     // because Name and/or Get_Name don't
     // work with default character?!?
     //
     Agent1.Characters.Unload('DefChar');
    end;
    //
    btnLoad.Caption:='Load';
    btnLoad.Enabled:=true;
    AgentLoaded:=false;
    //
    ckFast.checked := false;
    ckfast.enabled := false;
    lbfast.enabled := false;
    //
    // don't do this! it will cause subsequent loads to fail!
    //
    // ThisCharEx := nil;
end;

//
//  Mouse Events
//

procedure TfrmAgentTest.pnlLeftMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var aX, aY: integer;
begin
  //
  // a simple routine to make the agent chase the mouse click...
  //
  if (ckFollow.Checked and AgentLoaded) then begin
    aX:= frmAgentTest.Left + (Sender as TControl).Left + X
      - (ThisCharEx.Width div 2);
    aY:= frmAgentTest.Top + (Sender as TControl).Top + Y
      - (ThisCharEx.Height div 2);
    if ckRequest.Checked then begin
        ThisRequest :=ThisCharEx.Moveto(aX, aY, strtoint(edSpeed.text));
        Memo1.Lines.Add('Queued Request ID:' + inttostr(ThisRequest.ID));
        end
    else
    ThisCharEx.Moveto(aX, aY, strtoint(edSpeed.text));
    end;
end;

//
//  System Events
//

procedure TfrmAgentTest.Timer1Timer(Sender: TObject);
var msg: string;
begin
  //
  //  A bunch of ways to track a bunch of conditions and update the UI
  //
  try
  case ThisCharEx.SRStatus of
    0: msg := 'Conditions support speech input';
    1: msg := 'There is no audio input device available on this system';
    2: msg := 'Another client is the active client of this character';
    3: msg := 'The audio input or output channel is currently busy';
    4: msg := 'An unspecified error occurred initializing speech recognition';
    5: msg := 'The user has disabled speech input';
    6: msg := 'An unknown error occurred in checking the audio status';
    end;
  StatusBar2.Panels[0].text := msg;
  except
  StatusBar2.Panels[0].text := 'SRStatus unknown';
  end;
  //
  try
  if ThisCharEx.Commands.Count < 1 then
   statusbar1.panels[1].text := 'no commands'
  else
   statusbar1.panels[1].text := inttostr(ThisCharEx.Commands.Count)
    + ' commands';
  except
   statusbar1.panels[1].text := 'exception'
  end;
  //
  try
  case ThisCharEx.Active of
   0: statusbar2.panels[1].text := 'not active client';
   1: statusbar2.panels[1].text := 'active client';
   2: statusbar2.panels[1].text := 'input-active client';
   end;
  except
   statusbar2.panels[1].text := 'exception'
  end;
  //
  //
  //
  if AgentLoaded then begin
     btnLoad.Caption := 'Show';
     btnLoad.Enabled := not ThisCharEx.Get_Visible;
     end
  else
     btnLoad.Enabled:=true;
  //
  if AgentLoaded then
   btnHide.enabled:=ThisCharEx.Get_Visible
  else
   btnHide.enabled:=false;
  //
  btnListen.Enabled := AgentLoaded;
  btnPopUpMenu.Enabled := AgentLoaded;
  btnStopAll.Enabled:=AgentLoaded;
  btnTour.Enabled:=AgentLoaded;
  cbAnims.Enabled:=AgentLoaded;
  btnSpeak.Enabled:= AgentLoaded;
  btnUnLoad.Enabled:= AgentLoaded;
  btnAddCmds.Enabled:= AgentLoaded;
  btnAnimate.Enabled:= AgentLoaded;
  btnThink.Enabled := AgentLoaded;
  btnCharForm.Enabled := AgentLoaded;
  btnPropSheet.Enabled := AgentLoaded;
  btnListen.Enabled := AgentLoaded and (ThisCharEx.Commands.Count > 0);
  //
  //ckJustBalloon.Enabled := AgentLoaded;
  ckNoBalloon.Enabled := AgentLoaded;
  //
  if AgentLoaded then statusbar1.panels[2].text := ThisCharEx.name + ' loaded'
   else statusbar1.panels[2].text := 'no agent';
  //
end;

//
// Form Events
//

procedure TfrmAgentTest.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Agent1.Connected:=False;
end;

procedure TfrmAgentTest.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Timer1.Enabled:=False;
  //
  // this calls the routine whch waits for the agent to go
  // away before continuing. Makes for a more graceful exit
  // before the control gets 'disconnected'
  //
  if AgentLoaded then HideAgent;
end;

procedure TfrmAgentTest.StatusBar1Click(Sender: TObject);
begin
  lbStatus.Visible := True;
end;

procedure TfrmAgentTest.StatusBar1DblClick(Sender: TObject);
begin
  lbStatus.visible := false;
end;

//
// Buttons etc
//


procedure TfrmAgentTest.ckJustBalloonClick(Sender: TObject);
begin
  //
  //  you can get rid of the speech balloon throgh
  //    bit-wise setting of the Style property.
  //
  //  "thinking" always uses a balloon
  //
  if ckNoBalloon.checked then
     ThisCharEx.Balloon.Style := 14 //(SizeToText and
                                    //AutoHide and
                                    //AutoPace)
  else
     ThisCharEx.Balloon.Style := 15; //(BalloonOn and
                                     //SizeToText and
                                     //AutoHide and
                                     //AutoPace);
end;

procedure TfrmAgentTest.btnAnimateClick(Sender: TObject);
begin
  AnimateAgent;
end;

procedure TfrmAgentTest.btnLoadClick(Sender: TObject);
begin
  ckfast.enabled := true;
  lbfast.Enabled := true;
  if not AgentLoaded then LoadAgents;
  ShowAgent;
end;

procedure TfrmAgentTest.btnStopAllClick(Sender: TObject);
var Atype: OleVariant;
begin
  if AgentLoaded then begin
    //
    // StopAll requires a parameter, which could be a string to specify
    // 'Get' 'NonQueuedGet' ('Gets' are used for web based agents only)
    // 'Move' 'Play' or 'Speak'... but the empty parameter stops all types
    //
    // the alternative command Stop(IAgentCtlRequest) stops
    // only the specified request.
    //
    ThisCharEx.StopAll(Atype);
    end;
end;

procedure TfrmAgentTest.btnHideClick(Sender: TObject);
begin
  HideAgent;
end;

procedure TfrmAgentTest.btnUnLoadClick(Sender: TObject);
begin
  if AgentLoaded then UnLoadAgents;
end;

procedure TfrmAgentTest.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmAgentTest.btnAddCmdsClick(Sender: TObject);
begin
  AddCommands;
end;

procedure TfrmAgentTest.btnSpeakClick(Sender: TObject);
var i: integer;
  BText, Stext: string;
begin
  if AgentLoaded then begin
    Stext := '';
    for i := 0 to memo2.lines.count -1 do
      Stext := SText + Memo2.lines[i] + #32;
    Btext := SText;
    SpeakItV(Stext, Btext, false);
    end;
end;

procedure TfrmAgentTest.btnThinkClick(Sender: TObject);
var i: integer;
  BText, Stext: string;
begin
  if AgentLoaded then begin
    Stext := '';
    for i := 0 to memo2.lines.count -1 do
      Stext := Memo2.lines[i] + #32;
    Btext := SText;
    SpeakItV(Stext, Btext, true);
    end;
end;


procedure TfrmAgentTest.btnDefDialogClick(Sender: TObject);
begin
  Agent1.ShowDefaultCharacterProperties(frmAgentTest.Left + 10,
      frmAgentTest.Top + 20);
end;

procedure TfrmAgentTest.btnPopupMenuClick(Sender: TObject);
begin
  ThisCharEX.ShowPopUpMenu(ThisCharEx.Left + 10,
      ThisCharEx.Top + 20);
end;

procedure TfrmAgentTest.btnListenClick(Sender: TObject);
begin
  if btnListen.Caption = 'Listen!' then begin
    ThisCharEx.Listen(True);
    end
  else begin
    ThisCharEx.Listen(False);
    end;
end;

procedure TfrmAgentTest.btnPropSheetClick(Sender: TObject);
begin
  Agent1.PropertySheet.Visible := True;
  //
  // sort of simulate modal
  //
  While Agent1.PropertySheet.Get_Visible do begin
    end;
end;

procedure TfrmAgentTest.ckDefaultClick(Sender: TObject);
begin
  cbCharacters.enabled := not ckDefault.checked;
  if not messageshown then ShowMessage(
      'Once you load the Default character' + #13 + #10 +
      'then you cannot load a specified' + #13 + #10 +
      'character, and vice-versa.' + #13 + #10 +
      'even if you uncheck the box. Sorry!');
  messageshown := true;
end;

procedure TfrmAgentTest.btnTourClick(Sender: TObject);
  //
  // the subprocedures also contain Application.ProcessMessages loops,
  // so this may not be the best way to handle waiting for events to complete
  //
  // the Application.ProcessMessages loops cause the animation to
  // become slow and jerky. But by looping a little bit, you don't
  // you get stuck in the long sequence, and can stop it more easily.
  // [You can "interrupt" a request only if it comes from another agent;
  // i.e; merlin can interrupt a genie.request but not a merlin.request.]
  //
  //
  // -- local sub-procedures --
  //
  procedure WaitForIt;
  begin
  //
  // Note this only waits for the global <ThisRequest>
  // You could write the routine to take a specified request as a parameter
  //
  if ckWaitFor.Checked then begin
   while (((ThisRequest.Status <> 0)        // not completed
       and (ThisRequest.Status <> 1))       // not failed
       and (ThisRequest.Status <> 3)) do    // not interrupted
                                            // so it's  queued or in progress
       Application.ProcessMessages;         // and this smooths the wait
   end;
  end;

  procedure ExplainControl(aControl: TControl;
          aText: string; fast: integer);
  var aX, aY: integer;
  begin
  //
  // locate it
  //
  aX:=frmAgentTest.Left + aControl.parent.left + aControl.Left;
  aY:=frmAgentTest.Top + aControl.parent.Top + aControl.Top;
  //
  // move to the right of it
  //
  ThisCharEx.Moveto(aX+ + (ThisCharEx.Width),
     aY + (ThisCharEx.Height div 2), fast);
  ThisCharEx.GestureAt(aX, aY);
  //
  // make the speech
  //
  ThisRequest := ThisCharEx.Speak(aText,'');
  Application.ProcessMessages; //<--------------12/11/99
  //
  // wait before returning
  //
  Memo1.Lines.Add('Queued Request ID:' + inttostr(ThisRequest.ID));
  WaitForIt;
  end;

  procedure GestureAtControl(aControl: TControl;
          aText: string);
  var aX, aY: integer;
  begin
  //
  // locate it
  //
  aX:=frmAgentTest.Left + aControl.parent.left + aControl.Left;
  aY:=frmAgentTest.Top + aControl.parent.Top + aControl.Top;
  //
  // gesture at it (not usually very precise, depending on animation design)
  //
  ThisCharEx.GestureAt(aX, aY);
  //
  // make the speech
  //
  ThisRequest := ThisCharEx.Speak(aText,'');
  //
  // wait before returning
  //
  Memo1.Lines.Add('Queued Request ID:' + inttostr(ThisRequest.ID));
  WaitForIt;
  end;
  //
  //  -- beginning of main routine --
  //
begin
  cbCharacters.font.style := [fsBold];
  ExplainControl(cbCharacters,
    'These are the agents you have available',
    (strtoint(edSpeed.text)));
  cbCharacters.font.style := [];
  //
  memo2.font.style := [fsBold];
  GestureAtControl(Memo2,
    'I can speak anything you type in here');
  memo2.font.style := [];
  //
  memo1.font.style := [fsBold];
  ExplainControl(Memo1,
    'This output memo shows my \emp\command and \emp\request details',
    (strtoint(edSpeed.text)));
  memo1.font.style := [];
  //
  StatusBar1.Font.style := [fsBold];
  StatusBar2.Font.style := [fsBold];
  GestureAtControl(StatusBar1,
    'And the status messages show lots of action, \emp\condition and event details');
  StatusBar1.Font.style := [];
  StatusBar2.Font.style := [];
  //
  //
  btnLoad.Font.style := [fsBold];
  btnUnLoad.Font.style := [fsBold];
  btnHide.Font.style := [fsBold];
  ExplainControl(btnLoad, 'These 3 buttons load or unload me '
    + 'or hide me when I' + chr(39) + 'm loaded.',(strtoint(edSpeed.text)));
  btnLoad.Font.style := [];
  btnUnLoad.Font.style := [];
  btnHide.Font.style := [];
  //
  btnAddCmds.Font.style := [fsBold];
  GestureAtControl(btnAddCmds, 'And \emp\this adds commands to my menus');
  btnAddCmds.Font.style := [];
  //
  btnSpeak.Font.style := [fsBold];
  ExplainControl(btnSpeak, 'This button speaks whatever script you entered '
    + 'with or without the speech balloons',(strtoint(edSpeed.text)));
  btnSpeak.Font.style := [];
  //
  // -- added to demonstrate balloon showing
  // -- something other than the actual speech
  //
  SafePlay('GetAttention');
  SpeakItV('I can show something in the balloon but speak something different',
    'Four Score and Seven Years Ago...', false);
  //
  //
  btnTour.Font.style := [fsBold];
  GestureAtControl(btnTour, 'The Tour! button starts this tour with '
     + 'or without loops. Watch the memo box to see the difference.');
  btnTour.Font.style := [];
  //
  btnAnimate.Font.style := [fsBold];
  GestureAtControl(btnAnimate, 'The lower button starts another short but very '
     + 'clever animation sequence.');
  btnAnimate.Font.style := [];
  //
  // Note that the next move uses a 0 speed, so the agent will
  // Hop from one location to the other, without appropriate gesture
  // return animations being played. These 'Return' animations are
  // usually triggered by the next animation, if there is one.
  //
  ckFollow.Font.style := [fsBold];
  ckRequest.Font.style := [fsBold];
  ckFast.Font.style := [fsBold];
  ExplainControl(ckFollow, 'Check the first box, and I'+ chr(39) + 'll move to '
    + '\Emp\any mouse click on the form. '
    + 'Check the second box, and the program will generate '
    + 'even \Emp\more event requests which the memo will track. '
    + 'The third checkbox disables some of my \Emp\cute animations. ', 0);
  ckFollow.Font.style := [];
  ckRequest.Font.style := [];
  ckFast.Font.style := [];
  //
  // but of course, the use of Hide/Show animations, speech balloons, etc,
  // can also be overridden by the user or by another application.
  //
  btnStopAll.Font.style := [fsBold];
  ExplainControl(btnStopAll, 'This kills pending requests, and '
    + 'can break out of loops', (strtoint(edSpeed.text)));
  btnStopAll.Font.style := [];
  //
  btnClose.Font.style := [fsBold];
  ExplainControl(btnClose, 'And of course, the bottom right button shuts '
    + '\emp\me and the program down.', (strtoint(edSpeed.text)));
  btnClose.Font.style := [];
  //
  TourRequest := ThisCharEx.Play('Acknowledge');
end;

//
// initialize and display extended information form
//

procedure TfrmAgentTest.btnCharFormClick(Sender: TObject);
var i: integer;
begin
with TpagesDlg.Create(application) do
  try
    Caption:='All About ' + ThisCharEx.Name;
    memDesc.Text:=ThisCharEx.Description;
    edVersion.Text:=ThisCharEx.Version;
    memExtra.Text:=ThisCharEx.ExtraData;
    edGUIID.Text:=ThisCharEx.GUID;
    edSRModeID.Text:=ThisCharEx.SRModeID;
    edTTSModeID.Text:=ThisCharEx.TTSModeID;
    edPitch.text := inttostr(ThisCharEx.Pitch);
    edSpeed.text := inttostr(ThisCharEx.Speed);
    //
    ckVisible.Checked := ThisCharEx.Visible;
    ckAutoPopUp.Checked := ThisCharEx.AutoPopUpMenu;
    //
    // note the safety check for other applications
    //
    ckHasOtherClients.Checked := ThisCharEx.HasOtherClients;
    ckVisible.Enabled := not ckHasOtherClients.checked;
    //
    ckSoundEffectsOn.Checked := ThisCharEx.SoundEffectsOn;
    ckIdleOn.Checked := ThisCharEx.IdleOn;
    //
    edSRStatus.text := Statusbar2.panels[0].text;
    //
    edHelpFile.Text := ThisCharEx.HelpFile;
    edLanguageID.text := inttostr(ThisCharEx.LanguageID);
    //
    case ThisCharEx.VisibilityCause of
         0: edVisibilityCause.text :=
            'The character has not been shown';
         1: edVisibilityCause.text :=
            'User hid the character using the command on the character'
             + #39 + 's taskbar icon pop-up menu or using speech input';
         2: edVisibilityCause.text :=
            'The user showed the character.';
         3: edVisibilityCause.text :=
            'Your application hid the character';
         4: edVisibilityCause.text :=
            'Your application showed the character.';
         5: edVisibilityCause.text :=
            'Another client application hid the character';
         6: edVisibilityCause.text :=
            'Another client application showed the character.';
         7: edVisibilityCause.Text :=
            'The user hid the character using the command on the character'
             + #39 + 's pop-up menu';
         end;
    //
    case ThisCharEx.MoveCause of
         0: edLastMoveCause.text :=
            'The character has not been moved';
         1: edLastMoveCause.text :=
            'The user moved the character';
         2: edLastMoveCause.text :=
            'Your application moved the character';
         3: edLastMoveCause.text :=
            'Another client application moved the character';
         4: edLastMoveCause.text :=
            'The Agent server moved the character to keep it onscreen after'
              + ' a screen resolution change';
         end;
    //
    //'-- Check to see if the balloon is on and
    //'-- Set the controls based on Advanced ThisCharEx Options
    //
    If ThisCharEx.Balloon.Style And BalloonOn = BalloonOn Then begin
        ckBalloonEnabled.Checked := true;
        ckAutoHide.Enabled := True;
        ckAutoPace.Enabled := True;
        ckAutoSize.Enabled := True;
        end
    Else begin
        ckBalloonEnabled.Checked := False;
        ckAutoHide.Enabled := False;
        ckAutoPace.Enabled := False;
        ckAutoSize.Enabled := False;
        end;

    //'-- Check to see if Auto-Hide is on

    If ThisCharEx.Balloon.Style And AutoHide = AutoHide Then
        ckAutoHide.Checked := true
    Else
        ckAutoHide.Checked := false;

    //'-- Check to see if Auto-Pace is on

    If ThisCharEx.Balloon.Style And AutoPace = AutoPace Then
        ckAutoPace.Checked := true
    Else
        ckAutoPace.Checked := false;

    //'-- Check to see if Size-To-Text is on

    If ThisCharEx.Balloon.Style And SizeToText = SizetoText Then
        ckAutoSize.Checked := true
    Else
        ckAutoSize.Checked := false;
    //
    edBalloonStyle.Text := inttostr(ThisCharEx.Balloon.Style);
    //
    // enumerate the commands
    //
    grdCommands.Cells[1, 0] := 'Name';
    grdCommands.Cells[2, 0] := 'Voice';
    grdCommands.Cells[3, 0] := 'Caption';
    grdCommands.Cells[4, 0] := 'Enabled';
    grdCommands.Cells[5, 0] := 'Visible';
    grdCommands.Cells[6, 0] := 'VoiceCaption';
    //
    for i := 0 to ThisCharEx.Commands.Count - 1 do begin
      //
      // fill in string grid col, row with available data out of the
      // Commands objects. Note that you need to refer to the command
      // by name, so your code has to 'know' the name. I don't know
      // how to retrieve the 'names' so I use the same array I used
      // to add the commands. Circular? What if I wanted to read the
      // command names created by some other client of the agent?
      //
      grdCommands.Cells[0, i+1] :=  'Command #' + inttostr(i);
      grdCommands.Cells[1, i+1] := CmdName[i];
      grdCommands.Cells[2, i+1] :=
       ThisCharEx.Commands.Command(CmdName[i]).Voice;
      grdCommands.Cells[3, i+1] :=
       ThisCharEx.Commands.Command(CmdName[i]).Caption;
      //
      if ThisCharEx.Commands.Command(CmdName[i]).Enabled = true then
       grdCommands.Cells[4, i+1] := 'enabled'
      else
       grdCommands.Cells[4, i+1] := 'not enabled';
      //
      if ThisCharEx.Commands.Command(CmdName[i]).Visible = true then
       grdCommands.Cells[5, i+1] := 'visible'
      else
       grdCommands.Cells[5, i+1] := 'not visible';
      //
      grdCommands.Cells[6, i+1] := AgtCmdsEx[i].VoiceCaption;
      //
      edCommandCaption.text := ThisCharEx.Commands.Caption;
      edCommandVoiceCaption.text := ThisCharEx.Commands.VoiceCaption;
      edCommandVoice.text := ThisCharEx.Commands.Voice;
      edDefaultCommand.text := ThisCharEx.Commands.DefaultCommand;
      //
      end;
    //
    Showmodal;
  finally
    Free;
  end;
end;

//
// Agent Events
//

procedure TfrmAgentTest.Agent1Move(Sender: TObject;
  const CharacterID: WideString; x, y, Cause: Smallint);
var msg: string;
begin
  msg := CharacterID + ' moved to '
    + inttostr(x) + ', ' + inttostr (y);
  case Cause of
       0: statusmessage('not moved');
       1: statusmessage(msg + ' by the user');
       2: statusmessage(msg + ' by this application');
       3: statusmessage(msg + ' by another application');
       4: statusmessage(msg + ' by the Server');
       end;
end;

procedure TfrmAgentTest.Agent1Show(Sender: TObject;
  const CharacterID: WideString; Cause: Smallint);
var msg: string;
begin
  msg := CharacterID + ' showed';
  case Cause of
       2: statusmessage(msg + ' by the user');
       4: statusmessage(msg + ' by this application');
       6: statusmessage(msg + ' by another application');
       end;
end;

procedure TfrmAgentTest.Agent1Hide(Sender: TObject;
  const CharacterID: WideString; Cause: Smallint);
var msg: string;
begin
  msg := CharacterID + ' hidden';
  case Cause of
       0: statusmessage(' not shown');
       1: statusmessage(msg + ' by the user via taskbar or speech');
       3: statusmessage(msg + ' by this application');
       5: statusmessage(msg + ' by another application');
       7: statusmessage(msg + ' by user using pop-up');
       end;
end;

procedure TfrmAgentTest.Agent1Command(Sender: TObject;
  UserInput: IDispatch);
begin
  //
  // The following properties can be accessed from the UserInput object.
  // if it is type cast as IAgentCtlUserInput
  //
  // CharacterID     string: name (ID) of the character that rec'd command.
  // Name            string: name (ID) of the command.
  // Confidence      Long int: confidence scoring [-100 to 100].
  // Voice           string: voice text for the command.
  // Alt1Name        string: name of the next (second) best command.
  // Alt1Confidence  Long int: confidence scoring for the 2d best command.
  // Alt1Voice       string: voice text for the next best alt cmd match.
  // Alt2Name        string: name of third best command match.
  // Alt2Confidence  Long int: confidence scoring for the 3d best cmd match.
  // Alt2Voice       string: voice text for the 3d best command match.
  // Count           long int: number of alternatives returned.
  //
  ThisCmd := (Userinput as IAgentCtlUserInput);
  if ThisCmd.Name <> '' then begin
    memo1.Lines.Add(ThisCmd.CharacterID + ' received command ' + ThisCmd.Name);
    memo1.Lines.Add('with ' + inttostr(ThisCmd.confidence)
     +' confidence');
    //
    // What to do when a command is recognized, and
    // how to deal with confidence levels, alternatives,
    // and the context of the agent's and the user's
    // activities, is a vast subject. This stuff just
    // just represents a skeleton of a few obvious approaches.
    //
    if ThisCmd.Name = 'Wave' then
     if ThisCmd.Confidence > 30 then SafePlay('Wave')
      else SpeakItV('','...stop mumbling!', true);
    //
    if ThisCmd.Name = 'Jump' then
     if ThisCmd.Confidence > 30 then SafePlay('GetAttention')
      else SpeakItV('','Get the marbles out!', true);

    if ThisCmd.Name = 'Animate' then
     if ThisCmd.Confidence > 30 then btnAnimateClick(Self)
      else SpeakItV('','Huh?', true);

    //
    {'Jump', 'Wave', 'PropSheet', 'Tour', 'Animate', 'Relax'}
    //
    if ThisCmd.count > 1 then begin
      JustSpeak('That sounded like ' + ThisCmd.Voice + ', '
       +'at least that' + #39 + 's what I \emp\think you said.');
      memo1.Lines.Add('there are ' + inttostr(ThisCmd.count)
         + ' alternatives.');
      memo1.Lines.Add(ThisCmd.CharacterID + ' heard ' + ThisCmd.voice);
      memo1.Lines.Add('or maybe ' + ThisCmd.Alt1voice);
      memo1.Lines.Add('who knows.......');
      end;
     end
   else begin
     //ThisCharEx.Listen(false); // always turn off listening before speaking
     JustSpeak('\emp\That was no Stupid Agent Trick!');
     memo1.Lines.Add(ThisCmd.Voice + ' Not Recognized as "Stupid Agent Trick"');
     end;
end;

procedure TfrmAgentTest.Agent1IdleStart(Sender: TObject;
  const CharacterID: WideString);
begin
  statusmessage(CharacterID + ' Agent Idling; [Balloon Hidden]');
  //
  //  hide Balloon in case it's one of those that doesn't autohide
  //
  ThisCharEx.Balloon.Set_Visible(false);
end;

procedure TfrmAgentTest.Agent1ActivateInput(Sender: TObject;
  const CharacterID: WideString);
begin
  statusmessage(CharacterID + ' Agent Active for Input');
end;

procedure TfrmAgentTest.Agent1BalloonHide(Sender: TObject;
  const CharacterID: WideString);
begin
  statusmessage(CharacterID + ' Balloon Hidden');
end;

procedure TfrmAgentTest.Agent1BalloonShow(Sender: TObject;
  const CharacterID: WideString);
begin
  statusmessage(CharacterID + ' Balloon Shown');
end;

procedure TfrmAgentTest.Agent1Click(Sender: TObject;
  const CharacterID: WideString; Button, Shift, x, y: Smallint);
var msg: string;
begin
  //
  //  Decode SHIFT and BUTTON into strings
  //
  msg := BSDeCode(Button, Shift);
  //
  statusmessage(CharacterID + ' Clicked at '
     + inttostr(x) + ', ' + inttostr(y)
     + ' with ' + msg);
  // Under 1.5 You could show the property sheet by clicking
  // on the task bar icon, but not under 2.0
end;

procedure TfrmAgentTest.Agent1DblClick(Sender: TObject;
  const CharacterID: WideString; Button, Shift, x, y: Smallint);
var msg: string;
begin
  //
  //  Decode SHIFT and BUTTON into strings
  //
  msg := BSDeCode(Button, Shift);
  //
  statusmessage(CharacterID + ' Double Clicked at '
     + inttostr(x) + ', ' + inttostr(y)
     + ' with ' + msg);
end;

procedure TfrmAgentTest.Agent1DeactivateInput(Sender: TObject;
  const CharacterID: WideString);
begin
  statusmessage(CharacterID + ' Agent No Longer Active for Input');
end;

procedure TfrmAgentTest.Agent1DragComplete(Sender: TObject;
  const CharacterID: WideString; Button, Shift, x, y: Smallint);
var msg: string;
begin
  //
  //  Decode SHIFT and BUTTON into strings
  //
  msg := BSDeCode(Button, Shift);
  //
  statusmessage(CharacterID + ' Drag Complete at '
     + inttostr(x) + ', ' + inttostr(y)
     + ' with ' + msg);
end;

procedure TfrmAgentTest.Agent1DragStart(Sender: TObject;
  const CharacterID: WideString; Button, Shift, x, y: Smallint);
var msg: string;
begin
  //
  //  Decode SHIFT and BUTTON into strings
  //
  msg := BSDeCode(Button, Shift);
  //
  statusmessage(CharacterID + ' Drag Started at '
     + inttostr(x) + ', ' + inttostr(y)
     + ' with ' + msg);
end;

procedure TfrmAgentTest.Agent1IdleComplete(Sender: TObject;
  const CharacterID: WideString);
begin
  statusmessage(CharacterID + ' Stopped Idling');
end;

procedure TfrmAgentTest.Agent1Bookmark(Sender: TObject;
  BookmarkID: Integer);
begin
  statusmessage('BookMark Encountered, #'
     + inttostr(BookMarkID));
end;

procedure TfrmAgentTest.Agent1Restart(Sender: TObject);
begin
  statusmessage('Agent Restart Event'); //obslete in version 2.0
end;

procedure TfrmAgentTest.Agent1Shutdown(Sender: TObject);
begin
  statusmessage('Agent Shutdown Event'); //obsolete in version 2.0
end;

procedure TfrmAgentTest.Agent1Size(Sender: TObject;
  const CharacterID: WideString; Width, Height: Smallint);
begin
   statusmessage(CharacterID + ' Sized to '
      + inttostr(Width) + ' by ' +  inttostr(height));
end;

procedure TfrmAgentTest.Agent1RequestStart(Sender: TObject;
  Request: IDispatch);
var
  ARequest: IAgentCtlRequest;
  msg: string;
begin
  ARequest:=(Request as IAgentCtlRequest);
  case ARequest.Status of
       0: msg:='Request Successfully Completed';
       1: msg:='Request Failed';
       2: msg:='Request Pending in Queue';
       3: msg:='Request Interrupted';
       4: msg:='Request in Progress';
       end;
  Memo1.Lines.Add('Request ID:' + inttostr(ARequest.ID)
   + ', (ErrNo:' + inttostr(ARequest.Number) + ')'
     //+ ', Desc:' + ARequest.Description
     + ' Started.');
  Memo1.Lines.Add(msg);
  Memo1.Repaint;
end;

procedure TfrmAgentTest.Agent1RequestComplete(Sender: TObject;
  Request: IDispatch);
var
 ARequest: IAgentCtlRequest;
 msg: string;
begin
  ARequest:=(Request as IAgentCtlRequest);
  case ARequest.Status of
       0: msg:='Request Successfully Completed';
       1: msg:='Request Failed';
       2: msg:='Request Pending in Queue';
       3: msg:='Request Interrupted';
       4: msg:='Request in Progress';
       end;
  Memo1.Lines.Add('Request ID:' + inttostr(ARequest.ID)
   + ', (ErrNo:' + inttostr(ARequest.Number) + ')'
   //+ ', Desc:' + ARequest.Description
   + ' Completed.');
  Memo1.Lines.Add(msg);
  Memo1.Repaint;
end;

procedure TfrmAgentTest.Agent1ActiveClientChange(Sender: TObject;
  const CharacterID: WideString; Active: WordBool);
begin
  if Active then
    statusmessage(CharacterID +
     'Agent is client of this application')
  else
    statusmessage(CharacterID +
     'Agent is client of a different application');
end;

procedure TfrmAgentTest.Agent1HelpComplete(Sender: TObject;
  const CharacterID, Name: WideString; Cause: Smallint);
var
  msg: string;
begin
  case Cause of
    1: msg := 'Help Complete Via Application Command';
    2: msg := 'User Selected Another Client Commands';
    3: msg := 'User Selected Open Voice Commands';
    4: msg := 'User Selected Close Voice Commands';
    5: msg := 'User Selected Show Character Name';
    6: msg := 'User Selected Hide Character Name';
    7: msg := 'User Clicked the Character';
    end;
  Memo1.Lines.Add(CharacterID + ' ' + Name + ' Help Complete. '
     + msg);
end;

procedure TfrmAgentTest.Agent1ListenComplete(Sender: TObject;
  const CharacterID: WideString; Cause: Smallint);
var
  msg: string;
begin
  btnListen.Caption := 'Listen!';
  ThisCharEx.Listen(False);
  case Cause of
    1: msg := 'program code';
    2: msg := 'program code timed out';
    3: msg := 'listen key timed out';
    4: msg := 'listen key released';
    5: msg := 'finished speaking';
    6: msg := 'client deactivated';
    7: msg := 'default character changed';
    8: msg := 'user disabled input';
    end;
  statusmessage(CharacterID + ' Listen Complete: '
     + msg);
end;

procedure TfrmAgentTest.Agent1ListenStart(Sender: TObject;
  const CharacterID: WideString);
begin
  btnListen.Caption := 'Listening...';
  statusmessage(CharacterID + ' Listening...');
end;


procedure TfrmAgentTest.Agent1DefaultCharacterChange(Sender: TObject;
  const GUID: WideString);
begin
  statusmessage('Default Character Changed!');
end;

procedure TfrmAgentTest.Agent1AgentPropertyChange(Sender: TObject);
begin
  statusmessage('Agent Properties Changed!');
end;

//
// some useful functions and procs
//

function TfrmAgentTest.GetWinDirectory: String;
var
  WinDir: array[0..255] of Char;
begin
  GetWindowsDirectory(@WinDir, 255);
  Result := StrPas(WinDir);
end;

function TfrmAgentTest.BSDeCode(Button, Shift: smallint): string ;
var msg: string;
begin
  //
  //Button
  //	Returns an integer that identifies the button that was pressed
  //      and released to cause the event. The button argument is a bit
  //      field with bits corresponding to the left button (bit 0), right
  //      button (bit 1), and middle button (bit 2). These bits correspond
  //      to the values 1, 2, and 4, respectively. Only one of the bits
  //      is set, indicating the button that caused the event. If the
  //      character includes a taskbar icon, and bit 13 is also set, the
  //      click occurred on the taskbar icon.
  //Shift
  //      Returns an integer that corresponds to the state of the SHIFT,
  //      CTRL, and ALT keys when the button specified in the button
  //      argument is pressed or released. A bit is set if the key is
  //      down. The shift argument is a bit field with the
  //      least-significant bits corresponding to the SHIFT key (bit 0),
  //      the CTRL key (bit 1), and the ALT key (bit 2). These bits
  //      correspond to the values 1, 2, and 4, respectively. The shift
  //      argument indicates the state of these keys. Some, all, or none
  //      of the bits can be set, indicating that some, all, or none of
  //      the keys are pressed. For example, if both CTRL and ALT were
  //      pressed, the value of shift would be 6.
  //
  if (shift and 1) = 1 then msg := 'shift key -';
  if (shift and 2) = 2 then msg := msg + 'ctrl-';
  if (shift and 4) = 4 then msg := msg + 'alt-';
  if (button and 1) = 1 then msg := msg + 'left button ';
  if (button and 2) = 2 then msg := msg + 'right button ';
  if (button and 4) = 4 then msg := msg + 'middle button ';
  if (button and 4096) = 4096 then msg := msg + '(on taskbar)';
  //
  result := msg;
end;

procedure TfrmAgentTest.statusmessage(s: string);
begin
  LMDSimpleLabel1.Caption := s;
  lbStatus.Items.Add(formatdatetime('hh:mm:ss', now) + ': ' + s);
end;

procedure TfrmAgentTest.LMDInformationLabel2Click(Sender: TObject);
begin
  LMDInformationLabel2.Visible := False;
  case Ord(LMDInformationLabel2.Info) of
  0: LMDInformationLabel2.Info := Succ(LMDInformationLabel2.Info);
  1: LMDInformationLabel2.Info := Succ(LMDInformationLabel2.Info);
  2..14:  while (Ord(LMDInformationLabel2.Info) <> 15) do
    LMDInformationLabel2.Info := Succ(LMDInformationLabel2.Info);
  15..24: while (Ord(LMDInformationLabel2.Info) <> 25) do
    LMDInformationLabel2.Info := Succ(LMDInformationLabel2.Info);
  25..39: while (Ord(LMDInformationLabel2.Info) <> 40) do
    LMDInformationLabel2.Info := Succ(LMDInformationLabel2.Info);
  40: while (Ord(LMDInformationLabel2.Info) <> 0) do
    LMDInformationLabel2.Info := Pred(LMDInformationLabel2.Info);
  end;
  if Ord(LMDInformationLabel2.Info) = 40 then
        LMDInformationLabel2.UseStandardCaption := false
  else
        LMDInformationLabel2.UseStandardCaption := true;
  LMDInformationLabel2.Visible := True;
end;

procedure TfrmAgentTest.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
if panel.index = 0 then begin
   statusbar1.canvas.Font.color:=clNavy;
   Statusbar1.canvas.textRect(Rect, 3, 2, panel.text);
   end;
end;

end.
